  #include <Wire.h>

  // Custom I2C pins for ESP32C3
  #define I2C_SDA_PIN 7
  #define I2C_SCL_PIN 6

  void setup() {
    Serial.begin(115200);
    Wire.setPins(I2C_SDA_PIN, I2C_SCL_PIN);
    Wire.begin();
    Serial.println("Master ready. Scanning for slaves...");
    scanI2C();
  }

  void loop() {
    if (Serial.available()) {
      int value = Serial.parseInt();
      if (value >= 0 && value <= 255) {
        Serial.print("Sending value: ");
        Serial.println(value);
        Wire.beginTransmission(0x10); // Change to 0x20 for the second slave
        Wire.write(value);
        Wire.endTransmission();
      }
    }
  }

  void scanI2C() {
    byte error, address;
    int nDevices = 0;
    Serial.println("Scanning I2C bus...");
    for(address = 1; address < 127; address++) {
      Wire.beginTransmission(address);
      error = Wire.endTransmission();
      if (error == 0) {
        Serial.print("I2C device found at address 0x");
        Serial.println(address, HEX);
        nDevices++;
      }
    }
    if (nDevices == 0)
      Serial.println("No I2C devices found");
  }